program exercise6
  implicit none

  real*8, dimension(1:3,1:3) :: a, b, c, c2 ! 3x3の倍精度実数型の二次元配列(行列)を定義
  integer :: i, j, k
  
  ! 二次元配列に値をセット
  do j = 1, 3
     do i = 1, 3
        a(i,j) = exp(-abs(dble(i-j))) ! exp()の引数は倍精度実数型(整数型だとエラー)
        b(i,j) = exp( abs(dble(i-j)))
     end do
  end do

  ! a*bを代入する行列cの初期値をセット
  do j = 1, 3
     do i = 1, 3
        c(i,j) = 0.0d0
     end do
  end do
  ! c=0.0d0　や c(1:3,1:3) = 0.0d0としてもよい

  
  ! 行列の積を計算。3つのdoループが必要
  do j = 1, 3
     do i = 1, 3
        do k = 1, 3
           c(i,j) = c(i,j) + a(i,k) * b(k,j)
        end do
     end do
  end do

  ! 結果の出力
  do i = 1, 3
     print *, (c(i,j), j = 1, 3)  !この書き方は c(i,1), c(i,2), c(i,3)と同じ意味になる
  end do

  ! 組み込み関数matmulを用いた書き方
  c2(1:3,1:3) = matmul( a(1:3,1:3), b(1:3,1:3) )
  ! c2 = matmul(a,b)や c2(:,:)= matmul(a(:,:),b(:,:))でもよい
  

  print *, "" ! 空行を出力
  ! 結果の出力
  do i = 1, 3
     print *, (c2(i,j), j = 1, 3)
  end do
  
end program exercise6
